unit usercomm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TfmUserComment = class(TForm)
    btnCancel: TBitBtn;
    btnOK: TBitBtn;
    Bevel1: TBevel;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    btnLoad: TSpeedButton;
    btnSaveAs: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SpeedButton1: TSpeedButton;
    procedure btnSaveAsClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmUserComment: TfmUserComment;

implementation

uses
  main;

{$R *.DFM}

procedure TfmUserComment.btnSaveAsClick(Sender: TObject);
begin
  with saveDialog1 do begin
    initialDir := cheminApp + 'data\';
    if not execute then exit;
    try
      memo1.Lines.SaveToFile(fileName);
    except
    end;
  end;
end;

procedure TfmUserComment.btnLoadClick(Sender: TObject);
begin
  try
    memo1.Lines.LoadFromFile(CheminApp + 'userComm.rtf');
  except
  end;
end;

procedure TfmUserComment.FormActivate(Sender: TObject);
begin
  btnLoad.Enabled := fileExists(CheminApp + 'userComm.rtf');
end;

procedure TfmUserComment.btnOKClick(Sender: TObject);
begin
  try
    memo1.Lines.SaveToFile(CheminApp + 'userComm.rtf');
  except
  end;
end;

procedure TfmUserComment.SpeedButton1Click(Sender: TObject);
begin
  with openDialog1 do begin
    initialDir := cheminApp + 'data\';
    if not execute then exit;
    try
      memo1.Lines.LoadFromFile(fileName);
    except
    end;
  end;
end;

end.
