unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, ToolWin, StdCtrls, IniFiles, Menus, OoMisc, AdPort,
  Buttons, Gauges, ImgList;

type
  OneMes = record
    sDateTime: string;
    iValue: integer;
  end;
  TFmPrincipale = class(TForm)
    ToolBar1: TToolBar;
    btnOuvrir: TToolButton;
    btnSauverSous: TToolButton;
    btnQuitter: TToolButton;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    mnuFichier: TMenuItem;
    mnuQuitter: TMenuItem;
    mnuSauverSous: TMenuItem;
    N1: TMenuItem;
    mnuOuvrir: TMenuItem;
    mnuAide: TMenuItem;
    mnuAPropos: TMenuItem;
    ToolButton3: TToolButton;
    btnAide: TToolButton;
    btnImageList: TImageList;
    mnuAffichage: TMenuItem;
    mnuRaffraichirCourbe: TMenuItem;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    mnuAcquisition: TMenuItem;
    mnuDemarrerAcq: TMenuItem;
    mnuStopperAcq: TMenuItem;
    btnStartAcq: TToolButton;
    btnStopAcq: TToolButton;
    mnuIndexAide: TMenuItem;
    N3: TMenuItem;
    N2: TMenuItem;
    mnuOptions: TMenuItem;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    ApdComPort1: TApdComPort;
    mnuRAZInterface: TMenuItem;
    N4: TMenuItem;
    btnRAZInterface: TToolButton;
    ToolButton5: TToolButton;
    btnPrevFile: TToolButton;
    btnNextFile: TToolButton;
    mnuPrevFile: TMenuItem;
    mnuNextFile: TMenuItem;
    OpenDialog1: TOpenDialog;
    N5: TMenuItem;
    mnuImprimer: TMenuItem;
    N6: TMenuItem;
    btnAppercuImp: TToolButton;
    mnuAppercuImp: TMenuItem;
    mnuTypeAcq: TMenuItem;
    N7: TMenuItem;
    mnuEffacerCourbe: TMenuItem;
    mnuDelFiles: TMenuItem;
    N8: TMenuItem;
    OpenDialog2: TOpenDialog;
    mnuJDB: TMenuItem;
    led: TShape;
    btnJDB: TToolButton;
    ToolButton7: TToolButton;
    ProgList: TListBox;
    lblScale1: TLabel;
    lblScale2: TLabel;
    lblScale3: TLabel;
    lblScale4: TLabel;
    lblScale5: TLabel;
    btnLockEnrDD: TToolButton;
    lblLockEnrDD: TLabel;
    ToolButton8: TToolButton;
    mnuExporter: TMenuItem;
    mnuExporterBmp: TMenuItem;
    mnuExporterTxt: TMenuItem;
    mnuRAZEventCount: TMenuItem;
    pointer2: TImage;
    Pointer1: TImage;
    ledRecord: TShape;
    ToolButton9: TToolButton;
    btnPrint: TToolButton;
    ToolButton11: TToolButton;
    btnOptions: TToolButton;
    Gauge1: TGauge;
    ToolButton1: TToolButton;
    N9: TMenuItem;
    mnuTestGen: TMenuItem;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuQuitterClick(Sender: TObject);
    procedure mnuOuvrirClick(Sender: TObject);
    procedure mnuCopierClick(Sender: TObject);
    procedure mnuAProposClick(Sender: TObject);
    procedure mnuRaffraichirCourbeClick(Sender: TObject);
    procedure mnuDemarrerAcqClick(Sender: TObject);
    procedure mnuStopperAcqClick(Sender: TObject);
    procedure mnuIndexAideClick(Sender: TObject);
    procedure AppDeActivate(Sender: TObject);
    procedure mnuOptionsClick(Sender: TObject);
    procedure mnuSauverSousClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure mnuRAZInterfaceClick(Sender: TObject);
    procedure mnuPrevFileClick(Sender: TObject);
    procedure mnuNextFileClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuAppercuImpClick(Sender: TObject);
    procedure mnuImprimerClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnuTypeAcqClick(Sender: TObject);
    procedure mnuEffacerCourbeClick(Sender: TObject);
    procedure mnuDelFilesClick(Sender: TObject);
    procedure mnuJDBClick(Sender: TObject);
    procedure btnLockEnrDDClick(Sender: TObject);
    procedure mnuExporterBmpClick(Sender: TObject);
    procedure mnuExporterTxtClick(Sender: TObject);
    procedure mnuRAZEventCountClick(Sender: TObject);
    procedure mnuTestGenClick(Sender: TObject);
  private
    { Dclarations prives }

    bmpTmp: TBitmap;

    ConvCount: integer;  // pour ne pas prendre en compte la premire conversion
    MesCount: integer;   // pour enregistrement auto sur DD
    EOCCount: smallInt;  // vrification prsence EOC en sortie du CAN
    ErrorCount: integer; // compteur d'erreurs

    showCursors: boolean;
    moveCursors: boolean;
    {
    ActualPosYCursor: integer;
    OldPosYCursor: integer;
    }
    ActualPosXCursor: integer;
    OldPosXCursor: integer;

    procedure SetLblScale;
    procedure RefreshTitle;
    procedure RefreshControls;
    procedure ResetCursorsPos;

    procedure DrawBackGround(cl: TColor);
    procedure DrawGrid;
    procedure DrawThresholds;
    procedure DrawTrace(cl: TColor);
    procedure DrawAverageTrace(cl: TColor);
    procedure DrawCursors;
    procedure RefreshEventsGauge;
    procedure MAJStatus;

    procedure OpenFile(sFile: string);
    procedure SaveMesToFile;
    function GetfreeSpace(drive: char): integer;
    function GetNewFileName: TFileName;
    function PrevFile: string;
    function NextFile: string;

    function PrepareAutoProgList: boolean;
  public
    { Dclarations publiques }
    TblMes1: array[0..511] of OneMes;
    TblMes2: array[0..511] of OneMes;
    TblMes3: array[0..511] of OneMes;
    TblMes4: array[0..511] of OneMes;
    TblMes5: array[0..511] of OneMes;
    TblMes6: array[0..511] of OneMes;
    TblMes7: array[0..511] of OneMes;
    TblMes8: array[0..511] of OneMes;
    TblMes9: array[0..511] of OneMes;
    TblMes10: array[0..511] of OneMes;
    TblMes11: array[0..511] of OneMes;

    CANInputNum: byte;
    Data: array[0..9] of integer;

    PrintColor: boolean;
    acqMode: string[4];
    DataRecord, AlwaysDataRec: boolean;
    FreeDiskLimit: integer;

    BaseUnit, ScreenUnit: string[10];
    FactorUnit: string[10];
    ScreenPrecision: byte;

    AverageNum: integer;
    MaxCANValue, MinCANValue, CANValue: integer;
    MinUserValue, MaxUserValue, UserValue, DefaultValue: real;
    MinGraphUserValue, MaxGraphUserValue: real;
    MinGraphCANValue, MaxGraphCANValue: integer;
    GraphValue: integer;
    MinThreshold, MaxThreshold: real;
    OverMinThrCount, OverMaxThrCount: integer; // comptage des evenements
    BeginDateTime: TDateTime; // dbut du comptage des evenements

    LimitOverGraph: boolean;
    ShowThresholds: boolean;
    ShowAverageTrace: boolean;
    EOCControl: boolean;
    RAZAfterAcq: boolean;
    BGColor: TColor;
    GridColor: TColor;
    TraceColor: TColor;
    AverageTraceColor: TColor;
    CursorsColor: TColor;

    procedure DrawGraph(clBG, clTrace: TColor);
    procedure ReadUserPrefs;

    function CANStep: real;
    function GraphStep: real;
    function CANValueToGraphValue(i: integer): integer;
    function UserValueToGraphValue(r: real): integer;
    function CANValueToUserValue(i: integer): real;
    function UserValueToCANValue(r: real): integer;
    function CANValueToScreenValue(i: integer): string;
    function UserValueToScreenValue(r: real): string;

    procedure WriteAddr(state: boolean);
    procedure WriteCLK;
    procedure ReadData(Addr: string);
    function ReadDataBit: boolean;
    function ReadEOC: boolean;
    procedure RecLastMes;
  end;

const
  CR = #13;
  CRLF = #13#10;

var
  FmPrincipale: TFmPrincipale;
  CheminApp, AppIniFile, dataDir, openedFile: string;
  InitConvOK: boolean;
  MainTitle: string;
  runAcq, oldRunAcq, StopAcq: boolean;

implementation

uses
  rmMisc, options, report01, about, acqType, jdb, TestGene;

{$R *.DFM}

// -----------------------------------------------------------------------
// Initialisations diverses
// -----------------------------------------------------------------------

// activation-dsactivation bouttons barre d'outils et lements de menus
procedure TFmPrincipale.RefreshControls;
begin
  // si lancement en mode Test, tous bouttons et menus activs
  if (paramCount > 0) then
    if paramstr(1) = 'TEST' then exit;

  // bouttons de la barre d'outils
  btnOuvrir.enabled := not timer1.enabled;
  btnPrevFile.enabled := not timer1.enabled and fileExists(PrevFile);
  btnNextFile.enabled := not timer1.enabled and fileExists(NextFile);
  btnStartAcq.enabled := not timer1.enabled;
  btnStopAcq.enabled := timer1.enabled;
  btnOptions.enabled := not timer1.enabled;

  // menus
  mnuOuvrir.enabled := not timer1.enabled;
  mnuPrevFile.enabled := not timer1.enabled and fileExists(PrevFile);
  mnuNextFile.enabled := not timer1.enabled and fileExists(NextFile);
  mnuDemarrerAcq.enabled := not timer1.enabled;
  mnuStopperAcq.enabled := timer1.enabled;
  mnuOptions.enabled := not timer1.enabled;
  mnuDelFiles.enabled := not timer1.enabled;
  mnuTypeAcq.enabled := not timer1.enabled;
  mnuTestGen.enabled := not timer1.enabled;

  // JDB
  // plac dans un bloc try..except pour cacher l'exception provoque au dmarrage
  try
    fmJDB.Calendar.enabled := not timer1.enabled;
    fmJDB.btnOuvrir.enabled := not timer1.enabled;
    fmJDB.btnSauverSous.enabled := not timer1.enabled;
    fmJDB.btnImprimer.enabled := not timer1.enabled;
    fmJDB.btnCopier.enabled := not timer1.enabled;
    fmJDB.btnEffacer.enabled := not timer1.enabled;
    fmJDB.btnStartAcq.enabled := not timer1.enabled;
    fmJDB.btnStopAcq.enabled := timer1.enabled;
    fmJDB.mnuFichier.enabled := not timer1.enabled;
    fmJDB.mnuEdit.enabled := not timer1.enabled;
    fmJDB.mnuOptions.enabled := not timer1.enabled;
  except
  end;

end;

// Diverses initialisation au dmarrage
procedure TFmPrincipale.FormCreate(Sender: TObject);
begin
  Gauge1.Progress := 0;
  try
    bmpTmp := TBitmap.create;
    bmpTmp.width := paintBox1.width;
    bmpTmp.height := paintBox1.height;
  except
    showmessage('Cration du graphique temporaire impossible');
    bmpTmp.free;
    application.terminate;
  end;
  panel1.color := clBlack;
  MainTitle := '';
  CheminApp := extractFilePath(application.exeName);
  AppIniFile := changeFileExt(application.exeName, '.ini');
  application.helpFile := cheminApp + 'Data_acq.hlp';
  OpenedFile := 'SansNom';
  StatusBar1.panels[3].text := 'Acquisition stoppe';
  shortDateFormat := 'dd/mm/yyyy';
  application.onDeactivate := AppDeactivate;
  moveCursors := false;
  showCursors := true;
  ResetCursorsPos;

  // ouverture du port com
  ApdComPort1.open := true;
  OverMinThrCount := 0;
  OverMaxThrCount := 0;
  BeginDateTime := now;
  mnuRAZInterfaceClick(nil);
  RefreshControls;
end;

procedure TFmPrincipale.FormShow(Sender: TObject);
var
  i: integer;
begin
  i := FmChoixTypeAcq.showModal;
  if i = mrCancel then exit;

  // options utilisateur
  ReadUserPrefs;

  // raffraichissement de la barre de titre
  OpenedFile := 'SansNom';
  RefreshTitle;

  // remplissage du tableau de mesure par des valeurs fixes (valeur par dfaut)
  for i := 0 to 511 do begin
    TblMes1[i].sDateTime := '';
    TblMes1[i].iValue := UserValueToCANValue(DefaultValue);
  end;
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);

  application.processMessages;

  // si le type d'acquisition est tout nouveau, boite d'options immdiatement
  if (baseUnit = 'Unit') or (ScreenUnit = 'Unit') then mnuOptionsClick(nil);
end;

procedure TFmPrincipale.ResetCursorsPos;
begin
  {
  ActualPosYCursor := -1;
  OldPosYCursor := -1;
  }
  ActualPosXCursor := -1;
  OldPosXCursor := -1;
end;

procedure TFmPrincipale.AppDeactivate(Sender: TObject);
begin
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);
end;

procedure TFmPrincipale.ReadUserPrefs;
var
  ini: TIniFile;
  section: string;
begin
  // fig pour le moment
  MinCANValue := 0;
  MaxCANValue := 1023;

  section := 'Options-' + MainTitle;
  try
    ini := TIniFile.Create(AppIniFile);

    PrintColor := ini.ReadBool('General', 'PrintColor', false);
    Timer1.interval := ini.ReadInteger(section, 'TimerInterval', 300);
    if ini.ReadBool(section, 'AcquisitionMode', true) then acqMode := 'MANU' else acqMode := 'AUTO';
    StatusBar1.panels[2].text := 'Mode: ' + acqMode;
    dataDir := ini.ReadString(section, 'DataDir', cheminApp + 'data\');
    BGColor := ini.ReadInteger(section, 'BackGroundColor', clBlack);
    GridColor := ini.ReadInteger(section, 'GridColor', clSilver);
    TraceColor := ini.ReadInteger(section, 'TraceColor', clAqua);
    AverageTraceColor := ini.ReadInteger(section, 'AverageTraceColor', clYellow);
    CursorsColor := ini.ReadInteger(section, 'CursorColor', clYellow);
    AlwaysDataRec := ini.ReadBool(section, 'AlwaysDataRec', true);
    EOCControl := ini.ReadBool(section, 'EOCControl', true);
    RAZAfterAcq := ini.ReadBool(section, 'RAZAfterAcq', false);

    CANInputNum := ini.ReadInteger(section, 'CANInputNum', 1);

    BaseUnit := ini.ReadString(section, 'BaseUnit', '');
    ScreenUnit := ini.ReadString(section, 'ScreenUnit', '');
    FactorUnit := ini.ReadString(section, 'FactorUnit', '1');
    ScreenPrecision := ini.ReadInteger(section, 'ScreenPrecision', 0);

    AverageNum := ini.ReadInteger(section, 'AverageNum', 50);

    MinUserValue := strToReal(ini.ReadString(section, 'MinUserValue', '0'));
    MaxUserValue := strToReal(ini.ReadString(section, 'MaxUserValue', '10'));
    MinGraphUserValue := strToReal(ini.ReadString(section, 'MinGraphUserValue', '0'));
    MaxGraphUserValue := strToReal(ini.ReadString(section, 'MaxGraphUserValue', '10'));
    MinGraphCANValue := trunc((MinGraphUserValue * MaxCANValue) / (MaxUserValue - MinUserValue));
                        // + trunc((1023 * (MaxGraphUserValue - MinGraphUserValue)) / (MaxUserValue - MinUserValue));
    MaxGraphCANValue := trunc((MaxGraphUserValue * MaxCANValue) / (MaxUserValue - MinUserValue));
                        // + trunc((1023 * (MaxGraphUserValue - MinGraphUserValue)) / (MaxUserValue - MinUserValue));
    MinThreshold := strToReal(ini.ReadString(section, 'MinThreshold', '0'));
    MaxThreshold := strToReal(ini.ReadString(section, 'MaxThreshold', '0'));

    LimitOverGraph := ini.ReadBool(section, 'LimitOverGraph', true);
    ShowAverageTrace := ini.ReadBool(section, 'ShowAverageTrace', false);
    pointer1.visible := ShowAverageTrace;
    pointer2.visible := ShowAverageTrace;
    ShowThresholds := ini.ReadBool('General', 'ShowThresholds', true);
    Gauge1.MaxValue := ini.ReadInteger('General', 'MaxGauge', 30);
    FreeDiskLimit := ini.ReadInteger('General', 'FreeDiskLimit', 30);
    DefaultValue := strToReal(ini.ReadString(section, 'DefaultValue', '0'));
    try
      ApdComPort1.comNumber := ini.ReadInteger('General', 'ComNum', 1);
    except
      ApdComPort1.comNumber := 1;
      ini.WriteInteger('General', 'ComNum', 1);
      showMessage('Numro de port srie RS232 spcifi invalide.' + CR + 'Numro de port fix  Com 1.');
    end;
  finally
    ini.free;
  end;

  // mise  jour des labels de l'chelle
  SetLblScale;
end;

procedure TFmPrincipale.SetLblScale;
var
  r, factor: real;
begin

  factor := strToReal(factorUnit);
  try
    r := MinGraphUserValue * factor;
    lblScale1.caption := realToStr(screenPrecision, r) + ScreenUnit;
    r := ((((MaxGraphUserValue - MinGraphUserValue) / 4) * 1) + MinGraphUserValue) * factor;
    lblScale2.caption := realToStr(screenPrecision, r) + ScreenUnit;
    r := ((((MaxGraphUserValue - MinGraphUserValue) / 4) * 2) + MinGraphUserValue) * factor;
    lblScale3.caption := realToStr(screenPrecision, r) + ScreenUnit;
    r := ((((MaxGraphUserValue - MinGraphUserValue) / 4) * 3) + MinGraphUserValue) * factor;
    lblScale4.caption := realToStr(screenPrecision, r) + ScreenUnit;
    r := MaxGraphUserValue * factor;
    lblScale5.caption := realToStr(screenPrecision, r) + ScreenUnit;
  except
  end;
end;

procedure TFmPrincipale.RefreshTitle;
begin
  caption := MainTitle + ' - [' + extractFileName(OpenedFile) + ']';
end;

procedure TFmPrincipale.OpenFile(sFile: string);
var
  lst: TStringList;
  s: string;
  i: integer;
begin
  try
    lst := TStringList.create;
    lst.loadFromFile(sFile);
    for i := 0 to 511 do begin
      s := lst[i];
      TblMes1[i].sDateTime := copy(s, 1, pos('=', s) - 1);
      TblMes1[i].iValue := strToInt(copy(s, pos('=', s) + 1, 4));
    end;
  finally
    lst.free;
  end;

  // raffraichissement de la barre de titre
  OpenedFile := sFile;
  RefreshTitle;

  // raffraichissement graphique
  paintBox1Paint(nil);
  RefreshControls;
end;

function TFmPrincipale.PrevFile: string;

  function StrToIntOK(s: string): integer;
  begin
    try
      result := strToInt(s);
    except
      result := -1;
    end;
  end;

var
  FileNum: integer;
  s, sPath, sFile, newFile: string;
begin
  sPath := extractFilePath(openedFile);
  sFile := extractFileName(openedFile);
  s := copy(sFile, 2, 7);
  FileNum := strToIntOk(s);
  if (FileNum = -1) then begin
    result := '';
    exit;
  end;
  newFile := 'a' + format('%7s', [intToStr(FileNum - 1)]) + '.dat';
  while pos(' ', newFile) > 0 do newFile[Pos(' ' , newFile)] := '0';
  result := sPath + newFile;
end;

function TFmPrincipale.NextFile: string;

  function StrToIntOK(s: string): integer;
  begin
    try
      result := strToInt(s);
    except
      result := -1;
    end;
  end;

var
  FileNum: integer;
  s, sPath, sFile, newFile: string;
begin
  sPath := extractFilePath(openedFile);
  sFile := extractFileName(openedFile);
  s := copy(sFile, 2, 7);
  FileNum := strToIntOk(s);
  if (FileNum = -1) then begin
    result := '';
    exit;
  end;
  newFile := 'a' + format('%7s', [intToStr(FileNum + 1)]) + '.dat';
  while pos(' ', newFile) > 0 do newFile[Pos(' ' , newFile)] := '0';
  result := sPath + newFile;
end;

// -----------------------------------------------------------------------
// Commandes des menus
// -----------------------------------------------------------------------

procedure TFmPrincipale.mnuOuvrirClick(Sender: TObject);
begin
  with OpenDialog1 do begin
    iniTialDir := dataDir;
    fileName := '';
    if not execute then exit;
    openFile(fileName);
  end;
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);
end;

procedure TFmPrincipale.mnuPrevFileClick(Sender: TObject);
begin
  openFile(PrevFile);
  RefreshControls;
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);
end;

procedure TFmPrincipale.mnuNextFileClick(Sender: TObject);
begin
  openFile(NextFile);
  RefreshControls;
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);
end;

procedure TFmPrincipale.mnuSauverSousClick(Sender: TObject);
var
  lst: TStringList;
  i: integer;
begin
  with SaveDialog1 do begin
    fileName := '';
    defaultExt := 'dat';
    filter := 'Donnes (*.dat)|*.dat';
    initialDir := cheminApp + 'data';
    if not execute then exit;
    changeFileExt(fileName, 'dat');
    try
      lst := TStringList.create;
      for i := 0 to 511 do
        lst.add(TblMes1[i].sDateTime + '=' + intToStr(TblMes1[i].iValue));
      lst.saveToFile(fileName);
    finally
      lst.free;
    end;

    // raffraichissement de la barre de titre
    OpenedFile := fileName;
    RefreshTitle;
    RefreshControls;
  end;
end;

procedure TFmPrincipale.mnuExporterBmpClick(Sender: TObject);
var
  bmp: TBitmap;
  X, Y: integer;
  RectOrigin, RectDest: TRect;
begin
  with SaveDialog1 do begin
    fileName := '';
    defaultExt := 'bmp';
    filter := 'Bitmap (*.bmp)|*.bmp';
    initialDir := cheminApp + 'data';
    if not execute then exit;
    changeFileExt(fileName, 'bmp');
    // passage par un bitmap temporaire
    RectOrigin := rect(0,
                       0,
                       paintbox1.width,
                       paintbox1.height);
    RectDest :=   rect(1,
                       1,
                       paintbox1.width + 1,
                       paintbox1.height + 1);
    try
      bmp := TBitmap.create;
      bmp.width := paintbox1.width + bmp.canvas.textWidth(lblScale5.caption) + 5;
      bmp.height := paintbox1.height + 2;
      paintbox1Paint(nil);
      if not printColor then DrawGraph(clWhite, clBlack);
      bmp.canvas.Rectangle(0, 0, paintbox1.width + 2, paintbox1.height + 2);
      bmp.canvas.CopyRect(RectDest, paintbox1.canvas, RectOrigin);
      X := PaintBox1.Width + 3;
      Y := 0;
      bmp.canvas.textOut(X, Y, lblScale5.caption);
      Y := ((PaintBox1.height div 4) * 1) - (bmp.canvas.textHeight(lblScale4.caption) div 2);
      bmp.canvas.textOut(X, Y, lblScale4.caption);
      Y := ((PaintBox1.height div 4) * 2) - (bmp.canvas.textHeight(lblScale3.caption) div 2);
      bmp.canvas.textOut(X, Y, lblScale3.caption);
      Y := ((PaintBox1.height div 4) * 3) - (bmp.canvas.textHeight(lblScale2.caption) div 2);
      bmp.canvas.textOut(X, Y, lblScale2.caption);
      Y := PaintBox1.height - bmp.canvas.textHeight(lblScale1.caption);
      bmp.canvas.textOut(X, Y, lblScale1.caption);
      bmp.SaveToFile(fileName);
    finally
      bmp.free;
    end;
  end;
  paintbox1Paint(nil);
end;

procedure TFmPrincipale.mnuExporterTxtClick(Sender: TObject);
var
  sMsg: string;
  lst: TStringList;
  i, lineCount: integer;
  value: string;
begin
  with SaveDialog1 do begin
    fileName := '';
    defaultExt := 'txt';
    filter := 'Texte (*.txt)|*.txt';
    initialDir := cheminApp + 'data';
    if not execute then exit;
    changeFileExt(fileName, 'txt');
    try
      lst := TStringList.create;
      lst.add('Fichier de donnes export en texte le ' + dateToStr(now));
      lst.add('----------');
      lst.add('');
      lineCount := 0;
      for i := 0 to 511 do begin
        if TblMes1[i].sDateTime = '' then continue;
        value := CANValueToScreenValue(TblMes1[i].iValue);
        lst.add('Valeur  ' + TblMes1[i].sDateTime + ' : ' + value + ' ' + ScreenUnit);
        inc(lineCount);
      end;
      if lineCount = 0 then lst.add('Aucune donne valide  lire');
      lst.saveToFile(fileName);
    finally
      lst.free;
    end;
    if not timer1.enabled then begin
      sMsg := 'Visualiser le texte export ?';
      if messageDlg(sMsg, mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
        try
          winExec(PChar('Notepad.exe ' + fileName), SW_SHOWNORMAL);
        except
        end;
      end;
    end;
  end;
end;

procedure TFmPrincipale.mnuDelFilesClick(Sender: TObject);
var
  sMsg: string;
  i: integer;
begin

  with OpenDialog2 do begin
    initialDir := cheminApp + 'data\';
    if not execute then exit;
    sMsg := 'Attention !!!' + CR + 'Tous les fichiers de donnes slectionns vont tre supprims.' + CR +
            'Voulez-vous continuer ?';
    if messageDlg(sMsg, mtConfirmation, [mbYes, mbNo, mbCancel], 0) <> mrYes then exit;
    screen.cursor := crHourGlass;
    for i := 0 to files.Count - 1 do begin
      if fileExists(files[i]) then begin
        try
          deleteFile(files[i]);
        except
          screen.cursor := crDefault;
        end;
      end;
    end;
  end;
  screen.cursor := crDefault;
end;

procedure TFmPrincipale.mnuAppercuImpClick(Sender: TObject);
var
  frm: TFmReport01;
begin
  ResetCursorsPos;
  try
    screen.cursor := crHourGlass;
    frm := TFmReport01.create(self);
    frm.RefreshReport;
    screen.cursor := crDefault;
    frm.QuickRep1.Preview;
  finally
    screen.cursor := crDefault;
    frm.free;
  end;
  DrawGraph(BGColor, TraceColor);
end;

procedure TFmPrincipale.mnuImprimerClick(Sender: TObject);
var
  frm: TFmReport01;
begin
  ResetCursorsPos;
  try
    screen.cursor := crHourGlass;
    frm := TFmReport01.create(self);
    frm.RefreshReport;
    frm.QuickRep1.print;
  finally
    screen.cursor := crDefault;
    frm.free;
  end;
  DrawGraph(BGColor, TraceColor);
end;

procedure TFmPrincipale.mnuCopierClick(Sender: TObject);
begin
  showMessage('Fonction non implmente pour le moment.');
end;

procedure TFmPrincipale.mnuTypeAcqClick(Sender: TObject);
begin
  FmChoixTypeAcq.showModal;
  RefreshTitle;
end;

procedure TFmPrincipale.mnuDemarrerAcqClick(Sender: TObject);
VAR
  CanContinue: boolean;
  sMsg: string;
begin
  if timer1.enabled then exit;
  mnuRAZInterfaceClick(nil);

  // si mode d'enregistrement programm, vrification des plages horaires
  if acqMode = 'AUTO' then begin
    CanContinue := PrepareAutoProgList;
    if not CanContinue then begin
      sMsg := 'Vous tes en mode AUTO, et aucune ligne de programmation horaire n''est valide.' + CR +
              'Vous devez ajouter au moins une ligne valide, ou passer en mode MANU.' + CR +
              'Voulez-vous le faire maintenant ?';
      if (messageDlg(sMsg, mtWarning, [mbYes, mbNo], 0) = mrYes) then mnuOptionsClick(nil);
      exit;
    end;
  end;

  // remise  zro du JDB et du compteur d'evenements ?
  sMsg := 'Remettre le compteur d''vnements et le journal de bord  zro?';
  if (messageDlg(sMsg, mtConfirmation, [mbYes, mbNo], 0) = mrYes) then begin
    mnuRAZEventCountClick(nil);
    fmJdB.RichEdit1.clear;
  end;

  // raffraichissement cran
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);
  if AlwaysDataRec then DataRecord := true else DataRecord := false;

  // mise en avant du JdB
  FmJdB.show;
  fmJDB.insertStartAcq;

  // initialisation des variables
  fmJDB.oldValue := 0;
  OldRunAcq := true;
  StopAcq := false;
  InitConvOK := false;
  ConvCount := 0;
  MesCount := 0;
  EOCCount := 0;
  ErrorCount := 0;

  // dmarrage de l'acquisition
  Timer1.enabled := true;
  RefreshControls;
  StatusBar1.panels[3].text := 'Acquisition en cours...';
end;

procedure TFmPrincipale.mnuStopperAcqClick(Sender: TObject);
begin
  StopAcq := True;
  StatusBar1.panels[3].text := 'Acquisition stoppe';
end;

procedure TFmPrincipale.mnuOptionsClick(Sender: TObject);
var
  frm: TFmOptions;
begin
  try
    frm := TFmOptions.create(self);
    frm.showModal;
  finally
    frm.free;
  end;
  ReadUserPrefs;
  StatusBar1.panels[2].text := 'Mode: ' + acqMode;
  LedRecord.Brush.Color := clGray;
  gauge1.Progress := 0;
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);
end;

procedure TFmPrincipale.mnuRaffraichirCourbeClick(Sender: TObject);
begin
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);
end;

procedure TFmPrincipale.mnuEffacerCourbeClick(Sender: TObject);
var
  i: integer;
begin
  // remplissage du tableau de mesure par des valeurs fixes (valeur par dfaut)
  for i := 0 to 511 do begin
    TblMes1[i].sDateTime := '';
    TblMes1[i].iValue := UserValueToCANValue(DefaultValue);
  end;
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);

  // raffraichissement de la barre de titre et des controles
  OpenedFile := 'SansNom';
  RefreshTitle;
  RefreshControls;
end;

procedure TFmPrincipale.mnuRAZEventCountClick(Sender: TObject);
begin
  OverMinThrCount := 0;
  OverMaxThrCount := 0;
  BeginDateTime := now;
  fmJdB.sbJDB.simpleText := intToStr(OverMaxThrCount + OverMinThrCount) +
                                    ' vnement(s) depuis le ' + dateToStr(BeginDateTime) + '  ' + TimeToStr(BeginDateTime);
end;

procedure TFmPrincipale.mnuIndexAideClick(Sender: TObject);
begin
  application.helpCommand(help_Contents, 0);
end;

procedure TFmPrincipale.mnuJDBClick(Sender: TObject);
begin
  FmJdB.show;
  fmJDB.WindowState := wsNormal;
end;

procedure TFmPrincipale.btnLockEnrDDClick(Sender: TObject);
begin
  lblLockEnrDD.visible := btnLockEnrDD.Down;
end;

procedure TFmPrincipale.mnuAProposClick(Sender: TObject);
var
  frm: TFmAPropos;
begin
  try
    frm := TFmAPropos.create(self);
    frm.showModal;
  finally
    frm.free;
  end;
end;

procedure TFmPrincipale.mnuQuitterClick(Sender: TObject);
begin
  close;
end;

// -----------------------------------------------------------------------
// Commandes relatives au dessin du graphe (fond, rticule, courbe...)
// -----------------------------------------------------------------------

// Effacement des curseur si fentre minimise

// Procdure appele  chaque fois que le graphe doit tre redessin
procedure TFmPrincipale.PaintBox1Paint(Sender: TObject);
begin
  DrawGraph(BGColor, TraceColor);
end;

// Ensemble des procdures pour le dessin complet du graph
procedure TFmPrincipale.DrawGraph(clBG, clTrace: TColor);
var
  RectOrigin, RectDest: TRect;
begin
  try

    // dessin sur le bitmap temporaire
    DrawBackGround(clBG);
    DrawGrid;
    if ShowThresholds then DrawThresholds;
    DrawTrace(clTrace);
    if ShowAverageTrace then DrawAverageTrace(AverageTraceColor);

    // recopie sur paintBox1
    RectOrigin := rect(0, 0, bmpTmp.width, bmpTmp.height);
    RectDest := rect(0, 0, paintbox1.width, paintbox1.height);
    paintBox1.canvas.CopyRect(RectDest, bmpTmp.canvas, RectOrigin);
  finally
  end;

  // dessin (spar) du curseur de position temporelle
  if showCursors then begin
    DrawCursors;
    MAJStatus;
  end;
end;

// Effacement du graph par remplissage avec couleur de fond
procedure TFmPrincipale.DrawBackGround(cl: TColor);
begin
  with bmpTmp.canvas do begin
    brush.color := cl;
    pen.color := cl;
    pen.style := psSolid;
    fillRect(Rect(0, 0, PaintBox1.Width, PaintBox1.Height));
  end;
end;

// Dessin du rticule (grille en pointill)
procedure TFmPrincipale.DrawGrid;
var
  X1, Y1, X2, Y2: integer;
begin
  with bmpTmp.canvas do begin
    pen.color := GridColor;
    pen.style := psDot;
    {trac de la ligne repre horizontale N1}
    X1 := 0;
    Y1 := trunc((PaintBox1.height / 4) * 2);
    X2 := PaintBox1.width;
    Y2 := trunc((PaintBox1.height / 4) * 2);
    moveTo(X1, Y1);
    lineTo(X2, Y2);
    {trac de la ligne repre horizontale N2}
    X1 := 0;
    Y1 := trunc((PaintBox1.height / 4) * 3);
    X2 := PaintBox1.width;
    Y2 := trunc((PaintBox1.height / 4) * 3);
    moveTo(X1, Y1);
    lineTo(X2, Y2);
    {trac de la ligne repre horizontale N3}
    X1 := 0;
    Y1 := trunc(PaintBox1.height / 4);
    X2 := PaintBox1.width;
    Y2 := trunc(PaintBox1.height / 4);
    moveTo(X1, Y1);
    lineTo(X2, Y2);
  end;
end;

procedure TFmPrincipale.DrawThresholds;
var
  MaxThr, MinThr: integer;
begin
  with bmpTmp.canvas do begin
    pen.color := clRed;
    pen.style := psDash;

    MaxThr := UserValueToGraphValue(MaxThreshold);
    MinThr := UserValueToGraphValue(MinThreshold);

    // Seuil haut
    moveTo(0, MaxThr);
    lineTo(PaintBox1.width, MaxThr);
    // seuil bas
    moveTo(0, MinThr);
    lineTo(PaintBox1.width, MinThr);
  end;
end;

// Dessin de la courbe  partir des points mesurs
procedure TFmPrincipale.DrawTrace(cl: TColor);
var
  X, Y, i: integer;
begin
  with bmpTmp.canvas do begin
    pen.color := cl;
    pen.style := psSolid;

    // trac des points
    for i := 0 to 511 do begin
      X := i;

      CANValue := TblMes1[i].iValue;      // d'origine
      GraphValue := CANValueToGraphValue(CANValue);
      Y := GraphValue;

      if X = 0 then begin
        moveTo(X, 100);
        Y := 100;
      end;
      if X = 1 then begin
        moveTo(X, Y);
      end;
      lineTo(X, Y);
    end;
  end;
end;

// Dessin de la courbe moyenne  partir des points mesurs
procedure TFmPrincipale.DrawAverageTrace(cl: TColor);
var
  X, Y, i, iTmp, count, PointerPos: integer;
  s: string;
begin
  with bmpTmp.canvas do begin
    pen.color := cl;
    pen.style := psSolid;

    // trac des points
    for i := 0 to 511 do begin
      X := i;
      // moyennage sur les dernires valeurs
      iTmp := 0;
      if i < AverageNum - 1 then begin
        for count := 0 to i do iTmp := iTmp + TblMes1[i - count].iValue;
        iTmp := iTmp div (i + 1);
      end else begin
        for count := 0 to AverageNum - 1 do iTmp := iTmp + TblMes1[i - count].iValue;
        iTmp := iTmp div AverageNum;
      end;
      CANValue := iTmp;
      GraphValue := CANValueToGraphValue(CANValue);
      Y := GraphValue;

      if X = 0 then begin
        moveTo(X, 100);
        Y := 100;
      end;
      if X = 1 then begin
        moveTo(X, Y);
      end;
      lineTo(X, Y);

    end;
    s := CANValueToScreenValue(iTmp) + ' ' + ScreenUnit;
    font.color := cl;
    textOut(paintBox1.width - textWidth(s) - 1, paintBox1.height - textHeight(s) - 1, s);
  end;
  PointerPos := round((PaintBox1.height * (MaxGraphCANValue - (CANValue))) div (MaxGraphCANValue - MinGraphCANValue)) - 1;
  if pointerPos < 0 then pointerPos := 0;
  if pointerPos > (panel1.height - Pointer1.height) then pointerPos := (panel1.height - Pointer1.height);
  Pointer1.top := PointerPos;
  Pointer2.top := PointerPos;
end;

// Dessin d'un curseur vertical et d'un curseur horizontal
procedure TFmPrincipale.DrawCursors;
var
  X1, Y1, X2, Y2: integer;
  tempPenMode: TPenMode;
begin
  with PaintBox1.canvas do begin
    pen.color := CursorsColor;
    pen.style := psSolid;
    tempPenMode := pen.mode;
    pen.mode := pmXOr;

    // curseur vertical
    X1 := OldPosXCursor;
    Y1 := 0;
    X2 := ActualPosXCursor;
    Y2 := PaintBox1.height;
    moveTo(X1, Y1);
    lineTo(X1, Y2);
    moveTo(X2, Y1);
    lineTo(X2, Y2);

    {
    // curseur horizontal
    X1 := 0;
    Y1 := OldPosYCursor;
    X2 := PaintBox1.width;
    Y2 := ActualPosYCursor;
    moveTo(X1, Y1);
    lineTo(X2, Y1);
    moveTo(X1, Y2);
    lineTo(X2, Y2);
    }

    pen.mode := tempPenMode;
  end;
  MAJStatus;
end;

procedure TFmPrincipale.RefreshEventsGauge;
var
  i, GaugeCount: integer;
begin
  GaugeCount := 0;
  for i := 0 to 511 do
    if (CANValueToUserValue(TblMes1[i].iValue) > MaxThreshold)
    or (CANValueToUserValue(TblMes1[i].iValue) < MinThreshold) then
      inc(gaugeCount);
  gauge1.Progress := gaugeCount;
end;


// -----------------------------------------------------------------------
// Procdures et fonctions diverses
// -----------------------------------------------------------------------

function TFmPrincipale.CANStep: real;
begin
  try
    result := (MaxUserValue - MinUserValue) / (MaxCANValue - MinCANValue);
  except
    result := 0;
  end
end;

function TFmPrincipale.GraphStep: real;
begin
  try
    result := (MaxGraphUserValue - MinGraphUserValue) / paintBox1.height;
  except
    result := 0;
  end
end;

function TFmPrincipale.CANValueToGraphValue(i: integer): integer;
var
  value: real;
begin
  value := CANValueToUserValue(i);
  if (value < MinGraphUserValue) then begin
    if LimitOverGraph then result := paintBox1.height
    else result := paintBox1.height + 1;
  end else if (value > MaxGraphUserValue) then begin
    if LimitOverGraph then result := 0
    else result := - 1;
  end else begin
    try
      result := paintBox1.height - trunc(((Value - MinGraphUserValue) / GraphStep));
    except
      result := 0;
    end
  end;
end;

function TFmPrincipale.UserValueToGraphValue(r: real): integer;
begin
  if (r < MinGraphUserValue) then begin
    if LimitOverGraph then result := paintBox1.height
    else result := paintBox1.height + 1;
  end else if (r > MaxGraphUserValue) then begin
    if LimitOverGraph then result := 0
    else result := - 1;
  end else begin
    try
      result := paintBox1.height - trunc(((r - MinGraphUserValue) / GraphStep));
    except
      result := 0;
    end
  end;
end;

function TFmPrincipale.CANValueToUserValue(i: integer): real;
begin
  try
    result := (i * CANStep) + MinUserValue;
  except
    result := 0;
  end
end;

function TFmPrincipale.UserValueToCANValue(r: real): integer;
begin
  try
    result := round(((MaxCANValue - MinCANValue) / (MaxUserValue - MinUserValue)) * (r - MinUserValue));
  except
    result := 0;
  end
end;

function TFmPrincipale.CANValueToScreenValue(i: integer): string;
begin
  try
    result := UserValueToScreenValue(CANValueToUserValue(i));
  except
    result := '0';
  end
end;

function TFmPrincipale.UserValueToScreenValue(r: real): string;
var
  factor: real;
begin
  factor := strToReal(factorUnit);
  try
    result := realToStr(screenPrecision, factor * r);
  except
    result := '0';
  end;
end;

function TFmPrincipale.PrepareAutoProgList: boolean;
var
  i: integer;
  s: string;
  debut, fin: TDateTime;
begin
  try
    progList.items.loadFromFile(cheminApp + 'prog_acq.dat');
  except
    StopAcq := true;
    result := false;
    exit;
  end;

  // vrification validit des lignes de programmation horaire
  // et effacement des lignes qui n'ont plus lieu d'tre
  for i := progList.items.Count - 1 downTo 0 do begin
    s := progList.items[i];
    debut := strToDateTime(copy(s, 7, 10) + ' ' + copy(s, 18, 8));
    fin := strToDateTime(copy(s, 32, 10) + ' ' + copy(s, 43, 8));
    if now > fin then progList.items.delete(i);
  end;
  if progList.items.count = 0 then result := false else result := true;
end;

procedure TFmPrincipale.MAJStatus;
begin
  if (ActualPosXCursor < 0) or (ActualPosXCursor > PaintBox1.width) then begin
    StatusBar1.panels[0].text := '';
    StatusBar1.panels[1].text := '';
  end else begin
    StatusBar1.panels[0].text := TblMes1[ActualPosXCursor].sDateTime;
    UserValue := CANValueToUserValue(TblMes1[ActualPosXCursor].iValue);
    StatusBar1.panels[1].text := UserValueToScreenValue(UserValue) + ' ' + ScreenUnit;
  end;
end;

procedure TFmPrincipale.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (not moveCursors) or (not ShowCursors) then exit;
  if timer1.enabled then exit;
  if (X < 0) or (X > 511) then exit;
  OldPosXCursor := ActualPosXCursor;
  ActualPosXCursor := X;
  DrawCursors;
end;

procedure TFmPrincipale.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  moveCursors := true;
end;

procedure TFmPrincipale.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  moveCursors := false;
end;

procedure TFmPrincipale.Timer1Timer(Sender: TObject);
var
  drive: char;
  s: string;
  i: integer;
  FreeDiskSpace: longInt;
  debut, fin: TDateTime;
begin
  if led.brush.color = clGreen then led.brush.color := clLime else led.brush.color := clGreen;

  // l'utilisateur a-t-il demand l'arrt de l'acquisition ?
  if (StopAcq) then begin
    timer1.Enabled := false;
    led.brush.color := clGreen;
    RefreshControls;
    fmJDB.LastErrorString := '';
    fmJDB.LastEventString := '';
    fmJDB.insertEvent(fmJDB.sbJDB.SimpleText, clBlue);
    fmJDB.insertStopAcq;
    exit;
  end;

  runAcq := true; // reste vrai si on est en mode MANU

  // si mode d'enregistrement programm, vrification des plages horaires
  if acqMode = 'AUTO' then begin

    // analyse de la premire ligne de la table de programmation
    s := progList.items[0];
    debut := strToDateTime(copy(s, 7, 10) + ' ' + copy(s, 18, 8));
    fin := strToDateTime(copy(s, 32, 10) + ' ' + copy(s, 43, 8));
    // si elle encadre l'heure actuelle, on valide l'enregistrement de la mesure
    if ((now > debut) and (now < fin)) then runAcq := true else runAcq := false;
    // si la date de fin est dpasse, on efface la ligne
    if (now > fin) then begin
      progList.items.delete(0);
      runAcq := false;
    end;
    // mise  jour du journal de bord s'il y a changement d'tat
    if oldRunAcq <> runAcq then begin
      MesCount := 0;
      oldRunAcq := runAcq;
      if runAcq then begin
        MesCount := 0;
        fmJDB.insertEvent('Acquisition active (mode AUTO)', clGray);
        StatusBar1.panels[3].text := 'Acquisition en cours...';
        mnuRAZInterfaceClick(nil);
      end else begin
        MesCount := 500;
        fmJDB.insertEvent('Acquisition en pause (mode AUTO)', clGray);
        StatusBar1.panels[3].text := 'Acquisition en pause...';
      end;
    end;
    application.processMessages;
    // une fois la table vide, on arrte tout
    if progList.items.Count = 0 then begin
      mnuStopperAcqClick(nil);
      fmJDB.insertEvent('Arrt acquisition (table programmation horaire vide)', clGray);
    end;
  end;

  // lecture des donnes
  ReadData(byteToBits(CANInputNum - 1, 4));

  // vrification prsence du signal EOC
  // if EOCControl then begin
    if not readEOC then inc(EOCCount);
    if ReadEOC and (EOCCount > 2) then begin
      inc(ErrorCount);
      ConvCount := 0;
      EOCCount := 0;
      StatusBar1.panels[3].text := 'Acquisition en cours...';
      fmJDB.insertEndEvent('Acquisition en cours - Communication tablie');
      mnuRAZInterfaceClick(nil);
      fmJDB.LastErrorString := '';
    end;
    if EOCCount > 2 then begin
      if fmJDB.LastErrorString = '' then begin
        fmJDB.insertStartEvent('Acquisition en pause - Attente de communication');
        fmJDB.LastErrorString := 'Acquisition en pause - Attente de communication';
        StatusBar1.panels[3].text := 'Acquisition en pause - Attente de communication...';
      end;
    end;
  // end;

  // RAZ aprs la mesure ?
  if RAZAfterAcq then ApdComPort1.Output := 's';

  // enregistrement dans le tableau de mesures ?
  if (ConvCount > 1) and not(EOCCount > 2) then
    if runAcq then RecLastMes;
  inc(ConvCount);
  if convCount > 1000 then convCount := 2;

  // enregistrement sur DD ?
  if not btnLockEnrDD.Down then inc(MesCount);
  if MesCount > 500 then begin
    MesCount := 0;
    if DataRecord then begin
      // lecteur utilis pour la sauvegarde des donnes ?
      drive := 'a';
      if drive in ['a'..'z'] then dec(drive, $20);
      for i := 0 to 25 do begin
        if drive = copy(dataDir, 1, 1) then break;
        inc(drive, 1);
      end;
      // controle de l'espace disque encore disponible
      freeDiskSpace := GetFreeSpace(drive);
      if freeDiskSpace < FreeDiskLimit then begin
        StopAcq := true;
        StatusBar1.panels[3].text := 'Acquisition stoppe (manque espace disque)...';
        fmJDB.insertStartEvent('Acquisition stoppe (espace disque = ' + intToStr(FreeDiskSpace) + ' MO)...');
      end else begin
        SaveMesToFile;
      end;
    end;
    if not AlwaysDataRec then DataRecord := false;
  end;
  if DataRecord then ledRecord.brush.color := clRed else ledRecord.brush.color := clGray;
  RefreshEventsGauge;
end;

function TfmPrincipale.GetfreeSpace(drive: char): integer;
var
  freeSpace: longInt;
  drv: char;
begin
  drv := drive;
  if drv in ['a'..'z'] then dec(drv, $20);
  freeSpace := diskFree(ord(drv) - $40);
  result := freeSpace div 1048576;
end;

procedure TFmPrincipale.SaveMesToFile;
var
  lst: TStringList;
  newFile: string;
  i: integer;
begin
  try
    lst := TStringList.create;
    for i := 0 to 511 do lst.add(TblMes1[i].sDateTime + '=' + intToStr(TblMes1[i].iValue));
    newFile := GetNewFileName;
    lst.saveToFile(newFile);
    OpenedFile := newFile;
    fmJDB.insertEvent('Enregistrement des donnes dans ' + extractFileName(newFile), clGray);
    RefreshTitle;
  finally
    lst.free;
  end;
end;

function TFmPrincipale.GetNewFileName: TFileName;
var
  NewFileNum: integer;
  dir, sFile: string;
begin
  NewFileNum := 0;
  dir := dataDir;
  if copy(dir, length(dir), 1) <> '\' then dir := dir + '\';
  sFile := dir + 'a0000000.dat';
  While fileExists(sFile) do begin
    inc(NewFileNum);
    if NewFileNum > 9999998 then begin
      mnuStopperAcqClick(nil);
      fmJDB.insertEvent('Arrt acquisition (capacit incrmentation dpasse)', clRed);
    end;
    sFile := dir + 'a' + format('%7s', [intToStr(newFileNum)]) + '.dat';
    while pos(' ', sFile) > 0 do sFile[Pos(' ' , sFile)] := '0';
  end;
  result := sFile;
end;

procedure TFmPrincipale.WriteAddr(state: boolean);
begin
  // criture sur la broche RTS du port RS232
  // logique ngative (Addr = 1 si RTS = false)
  ApdComPort1.RTS := not state;
end;

procedure TFmPrincipale.WriteCLK;
begin
  // criture sur la broche DTR du port RS232
  // logique ngative (CLK = 1 si DTR = false)
  ApdComPort1.DTR := not ApdComPort1.DTR;
end;

function TFmPrincipale.ReadDataBit: boolean;
begin
  // lecture de la broche CTS du port RS232
  // logique negative (result = true si DATA OUT = 0)
  result := not ApdComPort1.CTS;
end;

function TFmPrincipale.ReadEOC: boolean;
begin
  // La lecture du EOC peut se faire  deux endroits
  // sur DSR : impulsion EOC en sortie directe du CAN
  // sur DCD : impulsion ralonge par monostable

  // lecture de la broche DCD du port RS232
  // logique ngative (result = true si EOC = 0)
  result := ApdComPort1.DCD;
  exit;

  // lecture de la broche DSR du port RS232
  // logique ngative (result = true si EOC = 0)
  result := ApdComPort1.DSR;
end;

procedure TFmPrincipale.RecLastMes;
var
  i, val: integer;
begin
  // traduction de la valeur binaire lue, en dcimal
  // cette valeur doit tre comprise entre 0 et 1023 (mesure sur 10 bits)
  val := 0;
  for i := 9 downTo 0 do begin
    case i of
      9 : if data[i] = 1 then val := val + 512;
      8 : if data[i] = 1 then val := val + 256;
      7 : if data[i] = 1 then val := val + 128;
      6 : if data[i] = 1 then val := val + 64;
      5 : if data[i] = 1 then val := val + 32;
      4 : if data[i] = 1 then val := val + 16;
      3 : if data[i] = 1 then val := val + 8;
      2 : if data[i] = 1 then val := val + 4;
      1 : if data[i] = 1 then val := val + 2;
      0 : if data[i] = 1 then val := val + 1;
    end;
  end;

  UserValue := CANValueToUserValue(val);

  // Comparaison avec les seuils fixs
  if (UserValue > maxThreshold) then begin
    if (fmJDB.LastEventString = '') or (val > fmJDB.oldvalue) then begin
      fmJDB.insertStartEvent('Dpassement seuil haut (' + UserValueToScreenValue(UserValue) + ' ' + BaseUnit + ')');
      fmJDB.LastEventString := 'MaxThresholdReached';
      fmJDB.oldvalue := val;
      if not DataRecord then MesCount := 0;
      dataRecord := true;
      inc(OverMaxThrCount);
      fmJdB.sbJDB.simpleText := intToStr(OverMaxThrCount + OverMinThrCount) +
                                       ' vnement(s) depuis le ' + dateToStr(BeginDateTime) + '  ' + TimeToStr(BeginDateTime);
    end;
  end;
  if (UserValue < maxThreshold) and (UserValue > minThreshold) then begin
    if fmJDB.LastEventString <> '' then begin
      fmJDB.insertEndEvent('Retour dans les limites');
      fmJDB.LastEventString := '';
      fmJDB.oldvalue := 0;
    end;
  end;
  if (UserValue < minThreshold) then begin
    if (fmJDB.LastEventString = '') or (val < fmJDB.oldvalue) then begin
      fmJDB.insertStartEvent('Dpassement seuil bas (' + UserValueToScreenValue(UserValue) + ' ' + BaseUnit + ')');
      fmJDB.LastEventString := 'MinThresholdReached';
      fmJDB.oldvalue := val;
      if not DataRecord then MesCount := 0;
      dataRecord := true;
      inc(OverMinThrCount);
      fmJdB.sbJDB.simpleText := intToStr(OverMaxThrCount + OverMinThrCount) +
                                       ' vnement(s) depuis le ' + dateToStr(BeginDateTime) + '  ' + TimeToStr(BeginDateTime);
    end;
  end;

  //Decallage des points de mesures stocks dans le tableau de mesure
  for i := 0 to 510 do tblMes1[i] := tblMes1[i + 1];
  tblMes1[511].sDateTime := dateToStr(now) + '-' + timeToStr(now);
  tblMes1[511].iValue := val;

  // raffraichissement graphique
  paintBox1Paint(nil);
end;

procedure TFmPrincipale.mnuRAZInterfaceClick(Sender: TObject);
begin
  ConvCount := 0;
  ApdComPort1.DTR := true;
  ApdComPort1.RTS := true;
  ApdComPort1.Output := 's';
end;

procedure TFmPrincipale.ReadData(Addr: string);
begin
  // CS passe a 0 : dbut du cycle
  // Ecriture du bit 3 de l'addresse
  if copy(Addr, 1, 1) = '1' then WriteAddr(true) else WriteAddr(false);

  // 1er front montant de l'horloge
  writeCLK;
  // prise en compte du bit 3 de l'addresse par le CI
  // lecture du bit 9 des donnees
  if ReadDataBit then data[9] := 1 else data[9] := 0;

  // 1er front descendant de l'horloge
  writeCLK;
  // Ecriture du bit 2 de l'addresse
  if copy(Addr, 2, 1) = '1' then WriteAddr(true) else WriteAddr(false);

  // 2eme front montant de l'horloge
  writeCLK;
  // prise en compte du bit 3 de l'addresse par le CI
  // lecture du bit 8 des donnees
  if ReadDataBit then data[8] := 1 else data[8] := 0;

  // 2eme front descendant de l'horloge
  writeCLK;
  // Ecriture du bit 1 de l'addresse
  if copy(Addr, 3, 1) = '1' then WriteAddr(true) else WriteAddr(false);

  // 3eme front montant de l'horloge
  writeCLK;
  // prise en compte du bit 3 de l'addresse par le CI
  // lecture du bit 7 des donnees
  if ReadDataBit then data[7] := 1 else data[7] := 0;

  // 3eme front descendant de l'horloge
  writeCLK;
  // Ecriture du bit 0 de l'addresse
  if copy(Addr, 4, 1) = '1' then WriteAddr(true) else WriteAddr(false);

  // 4eme front montant de l'horloge
  writeCLK;
  // prise en compte du bit 0 de l'addresse par le CI
  // lecture du bit 6 des donnees
  if ReadDataBit then data[6] := 1 else data[6] := 0;

  // 4eme front descendant de l'horloge
  writeCLK;
  // Rien

  // 5eme front montant de l'horloge
  writeCLK;
  // lecture du bit 5 des donnees
  if ReadDataBit then data[5] := 1 else data[5] := 0;

  // 5eme front descendant de l'horloge
  writeCLK;
  // Rien

  // 6eme front montant de l'horloge
  writeCLK;
  // lecture du bit 4 des donnees
  if ReadDataBit then data[4] := 1 else data[4] := 0;

  // 6eme front descendant de l'horloge
  writeCLK;
  // Rien

  // 7eme front montant de l'horloge
  writeCLK;
  // lecture du bit 3 des donnees
  if ReadDataBit then data[3] := 1 else data[3] := 0;

  // 7eme front descendant de l'horloge
  writeCLK;
  // Rien

  // 8eme front montant de l'horloge
  writeCLK;
  // lecture du bit 2 des donnees
  if ReadDataBit then data[2] := 1 else data[2] := 0;

  // 8eme front descendant de l'horloge
  writeCLK;
  // Rien

  // 9eme front montant de l'horloge
  writeCLK;
  // lecture du bit 1 des donnees
  if ReadDataBit then data[1] := 1 else data[1] := 0;

  // 9eme front descendant de l'horloge
  writeCLK;
  // Rien

  // 10eme front montant de l'horloge
  writeCLK;
  // lecture du bit 0 des donnees
  if ReadDataBit then data[0] := 1 else data[0] := 0;

  // 10eme front descendant de l'horloge
  writeCLK;
  // Rien
end;

procedure TFmPrincipale.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  res: integer;
  CanTerminate: boolean;
  sMsg: string;
begin
  CanTerminate := true;
  if timer1.enabled then begin
    CanTerminate := false;
    sMsg := 'Acquisition en cours.' + CR + 'Voulez-vous vraiment quitter?';
    res := messageDlg(sMsg, mtConfirmation, [mbYes, mbNo], 0);
    case res of
      mrYes : begin
                mnuStopperAcqClick(nil);
                CanTerminate := true;
              end;
      mrNo : begin
               CanTerminate := false;
               canClose := false;
               exit;
             end;
    end;
  end;
  if fmJDB.richEdit1.modified then begin
    sMsg := 'Le journal de bord n''est pas vide.' + CR + 'Voulez-vous l''enregistrer?';
    res := messageDlg(sMsg, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    case res of
      mrYes : begin
                fmJDB.mnuSauverSousClick(nil);
                CanTerminate := true;
              end;
      mrNo : ;
      mrCancel : CanTerminate := false;
    end;
  end;
  if canTerminate then begin
    application.onDeactivate := nil;
    bmpTmp.free;
  end;

  canClose := canTerminate;
end;

procedure TFmPrincipale.mnuTestGenClick(Sender: TObject);
var
  frm: TfmTestGenerator;
  i: integer;
begin
  try
    frm := TfmTestGenerator.create(self);
    i := frm.showModal;
  finally
    frm.free;
  end;
  if i <> mrOK then exit;
  ResetCursorsPos;
  DrawGraph(BGColor, TraceColor);

  // raffraichissement de la barre de titre et des controles
  OpenedFile := 'Signal Test';
  RefreshTitle;
  RefreshControls;
end;

end.
